#pragma once

#include <memory>
#include <vector>
#include "classicmode/classicnote.h"
#include "classicmode/context.h"
#include "editor/selectionmanager.h"

class ClassicGraphicsManager;

class EditorContext : public Context
{
public:
    explicit EditorContext(const std::shared_ptr<SelectionManager<ClassicNote>>& selection_manager,
                           std::vector<std::shared_ptr<ClassicGraphicsManager>>&& graphics_managers);

    virtual void input(ClassicArrowNote *note, kku::GameEvent&& input) const override;
    virtual void update(ClassicArrowNote *note, const kku::microsec &music_offset) const override;

    void inputUI(kku::GameEvent&& input);
    void updateGraphics(const kku::microsec& music_offset);
    void displayGraphics() const;

    std::shared_ptr<SelectionManager<ClassicNote>> getSelectionManager() const;

private:
    const std::shared_ptr<SelectionManager<ClassicNote>> _selection_manager;
    const std::vector<std::shared_ptr<ClassicGraphicsManager>> _graphics_managers;
};
